
{$APPTYPE GUI}{$MODE DELPHI}

program DemoSimplePlants;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_SimplePlants;

//const
 
//type
  
var 
  fico,cespuglio,palma1,pino,dracena,erba,mangrovia:gluint;
  canna:array[0..2]of gluint;

   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(tu,-tv, 0,-tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure MatFico;
begin
  TextureSelectID(1);
end;
 
procedure MatFoglieFico;
begin
  TextureTGASelectID(0);
end;
 
procedure ChiomaFico;
begin
  glPushMatrix;  
  glTranslatef(0,0.25,0);   
  glRotatef(180,0,1,0); 
  GenLeaf(2.5/10,2.5/10,0.35, 1,32, 0,0, 1,1,false);
  glPopMatrix;
end;


procedure MatCespuglio;
begin
  TextureSelectID(2);
end;
 
procedure MatFoglieCespuglio;
begin
  TextureTGASelectID(1);
end;
 
procedure ChiomaCespuglio;
begin
  glPushMatrix;  
  glTranslatef(0,0.25,0);   
  glRotatef(180,0,1,0); 
  GenLeaf(2.5/5,2.5/5,0.4, 1,32, 0,0, 1,1,false);
  glPopMatrix;
end;


procedure MatPalma1;
begin
  TextureSelectID(4);
end;
 
procedure MatFogliePalma1;
begin
  TextureTGASelectID(2);
end;
 
procedure ChiomaPalma1;
begin
  glPushMatrix;  
  glTranslatef(0,0.1,4);   
  glRotatef(180,0,1,0); 
  GenLeaf(1.25,4,1, 16,8, 0,0, 2,1,true);
  glPopMatrix;
end;


procedure MatPino;
begin
  TextureSelectID(2);
end;
 
procedure MatFogliePino;
begin
  TextureTGASelectID(3);
end;
 
procedure ChiomaPino;
begin
  glPushMatrix;     
  Quad(-0.35,0,0.35, 0.35,0,0.35, -0.35,0,-0.35*2, 0.35,0,-0.35*2, 1,1);
  glPopMatrix;
end;


procedure MatDracena;
begin
  TextureSelectID(3);
end;
 
procedure MatFoglieDracena;
begin
  TextureTGASelectID(4);
end;
 
procedure ChiomaDracena;
begin
  glPushMatrix;  
  glTranslatef(0,0.1,4/10);   
  glRotatef(180,0,1,0); 
  GenLeaf(1/10,10/10,3/10, 8,8, 0,0, 1,1,true);
  glPopMatrix;
end;


procedure MatMangrovia;
begin
  TextureSelectID(2);
end;
 
procedure MatFoglieMangrovia;
begin
  TextureTGASelectID(4);
end;
 
procedure ChiomaMangrovia;
begin
  glPushMatrix;  
  glTranslatef(0,0.25,0);   
  glRotatef(180,0,1,0); 
  Quad(-0.35,0,0.35, 0.35,0,0.35, -0.35,0,-0.35*2, 0.35,0,-0.35*2, 1,1);
  glPopMatrix;
end;


procedure MatErba1;
begin
  TextureTGASelectID(5);
end;

procedure MatErba2;
begin
  TextureTGASelectID(6);
end;

procedure MatErba3;
begin
  TextureTGASelectID(7);
end;


procedure MatCanna;
begin
  TextureSelectID(5);
end;
 
procedure MatFoglieCanna;
begin
  TextureTGASelectID(8);
end;
 
procedure ChiomaCanna;
begin
  glPushMatrix;  
  glTranslatef(0,0.25,0);   
  glRotatef(180,0,1,0); 
  Quad(-2/4,0,0, 2/4,0,0, -2/4,0,-2*4, 2/4,0,-2*4, 1,1);
  glPopMatrix;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('gras.bmp',0);
  TextureLoadID('corteccia01.bmp',1);
  TextureLoadID('corteccia02.bmp',2);
  TextureLoadID('corteccia00.bmp',3);
  TextureLoadID('corteccia03.bmp',4);  
  TextureLoadID('FustoVerde00.bmp',5);   
  TextureLoadTGAID('fico01.tga',0);
  TextureLoadTGAID('foglie00.tga',1);
  TextureLoadTGAID('palma01.tga',2); 
  TextureLoadTGAID('pino.tga',3);  
  TextureLoadTGAID('banano.tga',4);
  TextureLoadTGAID('erba01.tga',5);
  TextureLoadTGAID('erba00.tga',6);
  TextureLoadTGAID('erba02.tga',7);
  TextureLoadTGAID('graminacea00b.tga',8);  
  
end;
begin 

  OpenGL_Texture();
  
  BushAdvancedFractal3D(cespuglio,ChiomaCespuglio,MatCespuglio,MatFoglieCespuglio,12,4,1/5);
  
  TreeAdvancedFractal3D(fico,ChiomaFico,MatFico,MatFoglieFico,12,4,1/5);
  
  PalmAdvancedFractal3D(palma1,ChiomaPalma1,MatPalma1,MatFogliePalma1,12,4,1/5);
  
  Tree2AdvancedFractal3D(pino,ChiomaPino,MatPino,MatFogliePino,12,4,2/5);
  
  YuccaTypeAdvancedFractal3D(dracena,ChiomaDracena,MatDracena,MatFoglieDracena,12,4,2/5);
  
  MangroveTypeAdvancedFractal3D(mangrovia,ChiomaMangrovia,MatMangrovia,MatFoglieMangrovia,12,4,2/5);
  
  GrassAdvancedFractal3D(erba,MatErba1,MatErba2,MatErba3,6,1,2);  

  CaneAdvancedFractal3D(canna[0],ChiomaCanna,MatCanna,MatFoglieCanna,8,10,1/5);
  
  CaneAdvancedFractal3D(canna[1],ChiomaCanna,MatCanna,MatFoglieCanna,8,10,1/5);
  
  CaneAdvancedFractal3D(canna[2],ChiomaCanna,MatCanna,MatFoglieCanna,8,10,1/5);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-20);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(30,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, -10,10,0, 0.1); 

  // terreno
  TextureSelectID(0);
  Quad(-7,0,-7, 7,0,-7, -7,0,7, 7,0,7, 5,5); 

  // piante
  glPushMatrix;
  glTranslatef(-2,0,5);   
  glScalef(1.4,1.4,1.4);
  glCallList(Cespuglio);	
  glPopMatrix; 
 
  glPushMatrix;
  glTranslatef(0,0,1);   
  glScalef(2,2,2);
  glCallList(fico);	
  glPopMatrix; 

  glPushMatrix;
  glTranslatef(5,0,1);   
  glScalef(2,2,2);
  glCallList(palma1);	
  glPopMatrix;   
  
  glPushMatrix;
  glTranslatef(-5,0,-5);   
  glScalef(2,2,2);
  glCallList(pino);	
  glPopMatrix;   
  
  glPushMatrix;
  glTranslatef(2,0,-5);   
  glScalef(3,3,3);
  glCallList(dracena);	
  glPopMatrix;   
  
  glPushMatrix;
  glTranslatef(-5,0,2);   
  glScalef(1.6,1.6,1.6);
  glCallList(mangrovia);	
  glPopMatrix;  
    
  glPushMatrix;
  glTranslatef(5,0,5);   
  glCallList(canna[0]);	
  glPopMatrix; 
  glPushMatrix;
  glTranslatef(3.5,0,4);   
  glCallList(canna[1]);	
  glPopMatrix; 
  glPushMatrix;
  glTranslatef(6,0,3);   
  glCallList(canna[2]);	
  glPopMatrix;   
	
  glPushMatrix;
  glTranslatef(0,0,0);   
  glCallList(erba);	
  glPopMatrix;   
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Generazione di piante varie con frattali 3d', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
